<?php
/*
+--------------------------------------------------------------------------
|   IBITZY V 0.4 Beta
|   =============================================
|	  By: beeman / Jaggi
|	  Last Edited: 1/04/08 by phrostwave
+--------------------------------------------------------------------------
| Setup various parts of the plugin for the site
+--------------------------------------------------------------------------
*/

//--------------------------------
// Start class
//--------------------------------

class mininova
{
	/**
	* SETUP VARS
	*
	* to_spider = URL to page you wish to index
	* tinfo = the details page of the torrent
	* tinfo_url = full url of site to torrent details page
	* dl_link = full download url to torrent
	* dl_extra = some sites require trailing slashes or .torrent after the url, here u can do that
	* conf = this loads the conf class, don't edit
	*/
	
	var $to_spider	= 'http://www.mininova.org/cat-list/8/added';
	var $tinfo		= '/tor/';
	var $tinfo_url	= 'http://www.mininova.org/tor/';
	var $dl_link	= 'http://mininova.org/get/';
	var $dl_extra	= '';
	var $conf		= '';
	
	/*-------------------------------------------------------------------------*/
	// Main Match
	// > Get full url and torrent id 
	/*-------------------------------------------------------------------------*/ 	
	
	function main_match( $file )
	{
		preg_match_all( "#<a href=\"{$this->tinfo}(.+?)\">(.+?)</a>#ise", $file, $out );		
		foreach ( $out['1'] as $k )
		{
			$return[ $k ] = array( 'url' => $this->tinfo_url . $k, 'id' => $k );
		}
		return  $return;
	}

	/*-------------------------------------------------------------------------*/
	// Match Name
	// > Get torrent name
	/*-------------------------------------------------------------------------*/ 
	
	function match_name( $file ){   

	     preg_match( "#<h1>(.+?)</h1>#", $file,$out );
		return $out[1];
	}
  /*-------------------------------------------------------------------------*/
	// Match Seeds
	// > Get torrent seeds
	/*-------------------------------------------------------------------------*/
	function get_seeds($file)
	{ 
	if(preg_match("#<span class=\"r\">(.+?)</span>#" ,$file, $out)){
		return  $out[1];
	} elseif(preg_match("#<span class=\"g\">(.+?)</span>#" ,$file, $out)) {
	
	return  $out[1];
     
	}
	}
	
	/*-------------------------------------------------------------------------*/
	// Match Registration
	// > Get torrent registration
	/*-------------------------------------------------------------------------*/
	function get_registration($file) {
	  if (preg_match('#<p class="warning">#' ,$file, $out)) {
	       return $out = 1;
		   
		   } else {
		     return $out = 0;
			 }
			 }
	
	/*-------------------------------------------------------------------------*/
	// Match Description
	// > Get torrent description (not being used yet for AK Nova!!)
	/*-------------------------------------------------------------------------*/
	function get_description($file) {
	  if (preg_match('#<div id="description">#' ,$file, $out)) {
	     return $out[1];
                } 
                  else 
                     {
		        return $out = 0;
		     }
       }	
	
	/*-------------------------------------------------------------------------*/
	// Match Leechers
	// Get torrent leechers
	/*-------------------------------------------------------------------------*/
	function get_peers($file)
	{
	preg_match("#<span class=\"b\">(.+?)</span>#" ,$file, $out);
	return $out[1];
	}
	
	/*-------------------------------------------------------------------------*/
	// Match Downloads
	// Get torrents downloaded amount
	/*-------------------------------------------------------------------------*/
	function get_grabs($file)
	{
  preg_match("#<strong>Downloads:</strong> (.+?)#" ,$file, $out);
	return $out[1];
	}

	/*-------------------------------------------------------------------------*/
	// Match Category
	// > Get torrents category
	/*-------------------------------------------------------------------------*/ 
		
	function process_cat( $file )
	{
		preg_match( "#<strong>Category:</strong> <a href=\"/cat/(.+?)\">#", $file,	$out );
		return $out[1];
	}

	/*-------------------------------------------------------------------------*/
	// Match Subcategory
	// > Get torrent subcategory
	/*-------------------------------------------------------------------------*/ 
	
	function process_sub( $file )
	{
		preg_match( "#<a href=\"/sub/(\d+).+?\">#",	$file,	$out );
		return $out[1];
	}
	
	
	
	/*-------------------------------------------------------------------------*/
	// Match Magnet
	// > Get torrent magnet link (not in use in AK Nova)
	/*-------------------------------------------------------------------------*/ 
		
	function process_magnet( $file )
	{
		preg_match( "#<a href=\"magnet:(.+?)\">#",	$file,	$out );
		return  'magnet:'.$out[1];
	}
		
	function cat_code_extra( $cat="", $sub="" )
	{
		//-----------------------------------------
		// Match Array
		//-----------------------------------------
		
		//============================================================================================
		//  MININOVA ID => 'category name', main category array
		//  DO NOT CHANGE OR YOUR CATEGORIES WILL GET MESSED UP!
		//============================================================================================
		
    $pluggin_cats = array(
								1 => array( 'Anime', $this->conf['cats'][1][0] ),
								2 => array( 'Books', $this->conf['cats'][2][0] ),
								3 => array( 'Games', $this->conf['cats'][3][0] ),
								4 => array( 'Movies', $this->conf['cats'][4][0] ),
								5 => array( 'Music', $this->conf['cats'][5][0] ),
								7 => array( 'Softwere', $this->conf['cats'][6][0] ),
								8 => array( 'Misc', $this->conf['cats'][7][0] ),
							  );
                
		//-----------------------------------------
		// Check if we have match or set as other
		//  > Return cat id to class
		//-----------------------------------------
												
		$return_cat = !$pluggin_cats[ $cat ] ? $this->conf['cats'][8][0] : $pluggin_cats[ $cat ][1];
		
		return array( 'cat' => $return_cat, 'sub' => '' );
	}

	/*-------------------------------------------------------------------------*/
	// Match Download
	// > Setup the download url from where the torrents are downloaded
	/*-------------------------------------------------------------------------*/
	
	function process_download( $dlurl, $tinfo )
	{
		//-----------------------------------------
		// Construct and return url
		//-----------------------------------------
		
		$dlurl = $this->dl_link . $tinfo . $this->dl_extra;
		return $dlurl;
	}
}
?>